/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerTree"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerTree"] = true;
/* Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
	epages.cartridges.de_epages.presentation.widget.ProductPickerTree
*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductPickerTree");
dojo.require("epages.widget.Modaldialog");
dojo.require("epages.widget.FormElement");
dojo.require("epages.cartridges.de_epages.presentation.widget.Objectstore");
dojo.require("epages.cartridges.de_epages.presentation.widget.Objecttree");
dojo.require('epages.epages_scripts');
dojo.require('dijit.Dialog');

dojo.declare("epages.cartridges.de_epages.product.widget.ProductPickerTree",
	[epages.widget.LocalizedWidget],
	{
		/**
		* public properties
		*/
		query								: '',
		widgetsInTemplate		: true,
		templateString:"<div class=\"Linkcreator\">\n  <div class=\"TreeContainer\">\n    <div dojoType=\"dijit.tree.ForestStoreModel\" jsId=\"productPickerTreeModel\"\n            store=\"objectStore\" query=\"${query}\"\n            rootLabel=\"Startseite\" childrenAttrs=\"children\"></div>\n    <div dojoType=\"epages.cartridges.de_epages.presentation.widget.Objecttree\"\n         dojoAttachPoint=\"tree\"\n    \n         model=\"productPickerTreeModel\"\n         query=\"${query}\"\n         label=\"{StartPage}\"\n     ></div>\n  </div>\n</div>\n",
		translationName			: dojo.moduleUrl('epages.cartridges.de_epages.product.widget','templates/translation'),
		useAbsolutePath			: false,
		url									: '?',
		selectedProduct				: undefined,

		/*
		 * private properties
		 */
		_timestamp : undefined, // make something unique

		postMixInProperties: function() {
			// summary: create object store if not already present
			// override
			this._timestamp = (new Date()).getTime();
			if(window.objectStore === undefined){
				dojo.require("epages.cartridges.de_epages.presentation.widget.Objectstore");
				window.objectStore = new epages.cartridges.de_epages.presentation.widget.Objectstore({
					jsId:      "objectStore",
					id:        "objectStore",
					queryClasses: "Product,Category",
					ignoreSubproducts: "1"
				});
			}
			if (this.query == '') {
				if(epages.topWindow && epages.topWindow.objectStore && epages.topWindow.objectStore.objectId != null){
					this.query = "{id:" + epages.topWindow.objectStore.objectId + "}";
				}else{
					this.query = "{id:" + epages.vars.CategoriesID + "}";
				}
			}
			this.inherited('postMixInProperties', arguments);
		},

		postCreate: function() {
			// summary: connect to events
			// override
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.tree.id+'/select', this, function(selectedNode,a) {
				this.onSelectItem(selectedNode.item,selectedNode,a);
			});
		},
		selectedItem : function(){
			// summary: return currently selected item
			return this.selectedProduct;
		},
		onSelectItem: function(/*object*/data,item,a) {
			// summary: keep in mind which item is currently selected
			if(data.isProduct){
				this.selectedProduct = data;
			} else {
				//selected item is a folder --> no valid product
				this.selectedProduct = undefined;
			}
			dojo.publish(this.id+'/select',[this.selectedProduct]);
		}
	}
);

}
